// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
package org.chromium.base.test.util.parameter;

import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * BaseJUnit4ClassRunner and host side test harness skips commandline parameterization for test
 * classes or methods annotated with SkipCommandLineParameterization.
 *
 * This usually used by test that only runs in WebView javatests that only runs in sandboxed mode
 * or single process mode.
 */

@Inherited
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.METHOD, ElementType.TYPE})
public @interface SkipCommandLineParameterization {}
